commit 1d552de76fd321ca583f957a93a9a97cfd8064c9
Author: Daniel Neis Araujo <daniel@npd.ufsc.br>
Date:   Tue Dec 28 21:42:32 2010 -0200

    Show date range filter in one-line and move tabs to a dedicated partial.

diff --git a/app/views/time_entry_reports/report.rhtml b/app/views/time_entry_reports/report.rhtml
index 5ae9d65..d3a1ff8 100644
--- a/app/views/time_entry_reports/report.rhtml
+++ b/app/views/time_entry_reports/report.rhtml
@@ -14,6 +14,7 @@
   <%= hidden_field_tag('project_id', params[:project_id]) if @project %>
   <%= hidden_field_tag('issue_id', params[:issue_id]) if @issue %>
   <%= render :partial => 'timelog/date_range' %>
+  <%= render :partial => 'timelog/tabs' %>
 
   <p><%= l(:label_details) %>: <%= select_tag 'columns', options_for_select([[l(:label_year), 'year'],
                                                                             [l(:label_month), 'month'],
diff --git a/app/views/timelog/_date_range.rhtml b/app/views/timelog/_date_range.rhtml
index 727de25..e96930c 100644
--- a/app/views/timelog/_date_range.rhtml
+++ b/app/views/timelog/_date_range.rhtml
@@ -14,8 +14,6 @@
 													 :end => (text_field_tag('to', @to, :size => 10) + calendar_for('to'))) %>
 </span>
 </p>
-</div>
-</fieldset>
 <p class="buttons">
 	<%= link_to_remote l(:button_apply), 
 	                   { :url => { },
@@ -24,13 +22,6 @@
                             :method => :get
 	                   }, :class => 'icon icon-checked' %>
 </p>
-
-<div class="tabs">
-<% url_params = @free_period ? { :from => @from, :to => @to } : { :period => params[:period] } %>
-<ul>
-    <li><%= link_to(l(:label_details), url_params.merge({:controller => 'timelog', :action => 'index', :project_id => @project, :issue_id => @issue }),
-                                       :class => (@controller.action_name == 'index' ? 'selected' : nil)) %></li>
-    <li><%= link_to(l(:label_report), url_params.merge({:controller => 'time_entry_reports', :action => 'report', :project_id => @project, :issue_id => @issue}),
-                                       :class => (@controller.action_name == 'report' ? 'selected' : nil)) %></li>
-</ul>
 </div>
+</fieldset>
+
diff --git a/app/views/timelog/_tabs.rhtml b/app/views/timelog/_tabs.rhtml
new file mode 100644
index 0000000..93af05d
--- /dev/null
+++ b/app/views/timelog/_tabs.rhtml
@@ -0,0 +1,10 @@
+<div class="tabs">
+<% url_params = @free_period ? { :from => @from, :to => @to } : { :period => params[:period] } %>
+<ul>
+    <li><%= link_to(l(:label_details), url_params.merge({:controller => 'timelog', :action => 'index', :project_id => @project, :issue_id => @issue }),
+                                       :class => (@controller.action_name == 'index' ? 'selected' : nil)) %></li>
+    <li><%= link_to(l(:label_report), url_params.merge({:controller => 'time_entry_reports', :action => 'report', :project_id => @project, :issue_id => @issue}),
+                                       :class => (@controller.action_name == 'report' ? 'selected' : nil)) %></li>
+</ul>
+</div>
+
diff --git a/app/views/timelog/index.html.erb b/app/views/timelog/index.html.erb
index 737476f..5d8e74b 100644
--- a/app/views/timelog/index.html.erb
+++ b/app/views/timelog/index.html.erb
@@ -12,6 +12,7 @@ already in the URI %>
 <%= hidden_field_tag('project_id', params[:project_id]) if @project %>
 <%= hidden_field_tag 'issue_id', params[:issue_id] if @issue %>
 <%= render :partial => 'date_range' %>
+<%= render :partial => 'tabs' %>
 <% end %>
 
 <div class="total-hours">
diff --git a/public/stylesheets/application.css b/public/stylesheets/application.css
index feddfcb..fd4595b 100644
--- a/public/stylesheets/application.css
+++ b/public/stylesheets/application.css
@@ -280,7 +280,7 @@ fieldset.collapsible { border-width: 1px 0 0 0; font-size: 0.9em; }
 fieldset.collapsible legend { padding-left: 16px; background: url(../images/arrow_expanded.png) no-repeat 0% 40%; cursor:pointer; }
 fieldset.collapsible.collapsed legend { background-image: url(../images/arrow_collapsed.png); }
 
-fieldset#date-range p { margin: 2px 0 2px 0; }
+fieldset#date-range p { margin: 2px 0 2px 0; display: inline; }
 fieldset#filters table { border-collapse: collapse; }
 fieldset#filters table td { padding: 0; vertical-align: middle; }
 fieldset#filters tr.filter { height: 2em; }